Index: uspace/app/sbi/src/run_expr.c
===================================================================
--- uspace/app/sbi/src/run_expr.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/sbi/src/run_expr.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -2886,5 +2886,5 @@
 				/* Is it static/nonstatic? */
 				var_sn = stree_symbol_has_attr(
-				    var_to_symbol(var), sac_static);
+				    var_to_symbol(var), sac_static) ? sn_static : sn_nonstatic;
 				if (var_sn == sn) {
 					/* Compute field type. XXX Memoize. */
Index: uspace/app/sysinst/sysinst.c
===================================================================
--- uspace/app/sysinst/sysinst.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/sysinst/sysinst.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 #include <block.h>
 #include <byteorder.h>
+#include <cap.h>
 #include <errno.h>
 #include <fdisk.h>
@@ -89,5 +90,5 @@
 	fdisk_part_t *part;
 	fdisk_part_spec_t pspec;
-	fdisk_cap_t cap;
+	cap_spec_t cap;
 	service_id_t sid;
 	int rc;
@@ -171,6 +172,7 @@
 
 	printf("sysinst_fs_mount(): verify filesystem server result\n");
-	if (texit != TASK_EXIT_NORMAL || trc != 0)
-		return EIO;
+	if (texit != TASK_EXIT_NORMAL || trc != 0) {
+		printf("sysinst_fs_mount(): not successful, but could be already loaded.\n");
+	}
 
 	rc = vfs_link_path(MOUNT_POINT, KIND_DIRECTORY, NULL);
@@ -209,6 +211,7 @@
 
 	printf("sysinst_copy_boot_files(): verify filesystem server result\n");
-	if (texit != TASK_EXIT_NORMAL || trc != 0)
-		return EIO;
+	if (texit != TASK_EXIT_NORMAL || trc != 0) {
+		printf("sysinst_fs_mount(): not successful, but could be already loaded.\n");
+	}
 
 	printf("sysinst_copy_boot_files(): create CD mount point\n");
Index: uspace/app/taskdump/taskdump.c
===================================================================
--- uspace/app/taskdump/taskdump.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/taskdump/taskdump.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,5 +44,4 @@
 #include <task.h>
 #include <as.h>
-#include <sys/typefmt.h>
 #include <libarch/istate.h>
 #include <macros.h>
Index: uspace/app/tester/hw/misc/virtchar1.c
===================================================================
--- uspace/app/tester/hw/misc/virtchar1.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/tester/hw/misc/virtchar1.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -60,5 +60,5 @@
 			    "have you compiled test drivers?)\n");
 		}
-		return "Failed opening devman driver device for reading";
+		return "Failed opening NULL device for reading";
 	}
 	
Index: uspace/app/testread/testread.c
===================================================================
--- uspace/app/testread/testread.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/testread/testread.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -54,8 +54,8 @@
 #include <loc.h>
 #include <byteorder.h>
-#include <sys/typefmt.h>
 #include <inttypes.h>
 #include <errno.h>
 #include <time.h>
+#include <offset.h>
 
 #define NAME	"testread"
Index: uspace/app/tetris/scores.c
===================================================================
--- uspace/app/tetris/scores.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/tetris/scores.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -65,5 +65,4 @@
 #include <vfs/vfs.h>
 #include <stdlib.h>
-#include <err.h>
 #include <time.h>
 #include "screen.h"
Index: uspace/app/tetris/screen.c
===================================================================
--- uspace/app/tetris/screen.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/tetris/screen.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -54,5 +54,4 @@
  */
 
-#include <err.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -198,5 +197,6 @@
 		scr_end();
 	
-	errx(1, "aborting: %s", why);
+	fprintf(stderr, "aborting: %s", why);
+	abort();
 }
 
Index: uspace/app/tetris/screen.h
===================================================================
--- uspace/app/tetris/screen.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/tetris/screen.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -55,5 +55,5 @@
 #define putpad(s)  tputs(s, 1, put)
 
-#include <libarch/types.h>
+#include <types/common.h>
 #include <io/console.h>
 #include <async.h>
Index: uspace/app/tetris/tetris.c
===================================================================
--- uspace/app/tetris/tetris.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/tetris/tetris.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -56,5 +56,4 @@
 
 #include <sys/time.h>
-#include <err.h>
 #include <errno.h>
 #include <stdio.h>
@@ -289,6 +288,8 @@
 	for (i = 0; i <= 5; i++) {
 		for (j = i + 1; j <= 5; j++) {
-			if (keys[i] == keys[j])
-				errx(1, "%s", "duplicate command keys specified.");
+			if (keys[i] == keys[j]) {
+				fprintf(stderr, "duplicate command keys specified.");
+				abort();
+			}
 		}
 		
@@ -442,4 +443,5 @@
 void usage(void)
 {
+	fprintf(stderr, "%s", copyright);
 	fprintf(stderr, "usage: tetris [-ps] [-k keys]\n");
 	exit(1);
Index: uspace/app/top/top.c
===================================================================
--- uspace/app/top/top.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/top/top.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -42,5 +42,5 @@
 #include <sys/time.h>
 #include <errno.h>
-#include <sort.h>
+#include <gsort.h>
 #include "screen.h"
 #include "top.h"
Index: uspace/app/trace/ipc_desc.c
===================================================================
--- uspace/app/trace/ipc_desc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/trace/ipc_desc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,6 +40,4 @@
 	/* System methods */
 	{ IPC_M_PHONE_HUNGUP,     "PHONE_HUNGUP" },
-	{ IPC_M_CONNECTION_CLONE, "CONNECTION_CLONE" },
-	{ IPC_M_CLONE_ESTABLISH,  "CLONE_ESTABLISH" },
 	{ IPC_M_CONNECT_ME_TO,    "CONNECT_ME_TO" },
 	{ IPC_M_CONNECT_TO_ME,    "CONNECT_TO_ME" },
Index: uspace/app/trace/ipcp.c
===================================================================
--- uspace/app/trace/ipcp.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/trace/ipcp.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,6 +35,6 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <inttypes.h>
 #include <adt/hash_table.h>
-#include <sys/typefmt.h>
 #include <abi/ipc/methods.h>
 #include <macros.h>
Index: uspace/app/trace/syscalls.c
===================================================================
--- uspace/app/trace/syscalls.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/trace/syscalls.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -68,6 +68,6 @@
     [SYS_IPC_EVENT_UNMASK] = { "ipc_event_unmask",	1,	V_ERRNO },
 
-    [SYS_CAP_GRANT] = { "cap_grant",			2,	V_ERRNO },
-    [SYS_CAP_REVOKE] = { "cap_revoke",			2,	V_ERRNO },
+    [SYS_PERM_GRANT] = { "perm_grant",			2,	V_ERRNO },
+    [SYS_PERM_REVOKE] = { "perm_revoke",		2,	V_ERRNO },
     [SYS_PHYSMEM_MAP] = { "physmem_map",		4,	V_ERRNO },
     [SYS_IOSPACE_ENABLE] = { "iospace_enable",		1,	V_ERRNO },
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/trace/trace.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 #include <stdint.h>
 #include <stddef.h>
+#include <inttypes.h>
 #include <fibril.h>
 #include <errno.h>
@@ -49,5 +50,4 @@
 #include <io/keycode.h>
 #include <fibril_synch.h>
-#include <sys/typefmt.h>
 #include <vfs/vfs.h>
 
Index: uspace/app/trace/trace.h
===================================================================
--- uspace/app/trace/trace.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/trace/trace.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define TRACE_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 /**
Index: uspace/app/usbinfo/usbinfo.h
===================================================================
--- uspace/app/usbinfo/usbinfo.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/usbinfo/usbinfo.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,5 +40,4 @@
 #include <usb/dev/device.h>
 #include <usb/dev/dp.h>
-#include <ipc/devman.h>
 
 typedef struct {
Index: uspace/app/vlaunch/Makefile
===================================================================
--- uspace/app/vlaunch/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/vlaunch/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,16 +43,29 @@
 MATH = y
 
+IMG = image
+IMGS = $(IMG)s
+
 SOURCES = \
 	vlaunch.c \
-	images.s
+	$(IMGS).s \
+	$(IMGS)_desc.c
 
 IMAGES = \
 	gfx/helenos.tga
 
-PRE_DEPEND = images.s images.h
-EXTRA_CLEAN = images.s images.h
+PRE_DEPEND = $(IMGS).s $(IMGS).h $(IMGS)_desc.c
+EXTRA_CLEAN = $(IMGS).s $(IMGS).h $(IMGS)_desc.c $(IMGS).zip
 
 include $(USPACE_PREFIX)/Makefile.common
 
-images.s images.h: $(IMAGES)
-	$(ROOT_PATH)/tools/mkarray.py images COMPOSITOR_IMAGES "$(AS_PROLOG)" $^
+$(IMGS).s: $(IMGS).zip
+	unzip -p $< $@ > $@
+
+$(IMGS).h: $(IMGS).zip
+	unzip -p $< $@ > $@
+
+$(IMGS)_desc.c: $(IMGS).zip
+	unzip -p $< $@ > $@
+
+$(IMGS).zip: $(IMAGES)
+	$(ROOT_PATH)/tools/mkarray.py $(IMGS) $(IMG) "$(AS_PROLOG)" .data $^
Index: uspace/app/websrv/websrv.c
===================================================================
--- uspace/app/websrv/websrv.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/websrv/websrv.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -75,12 +75,14 @@
 static uint16_t port = DEFAULT_PORT;
 
-static char rbuf[BUFFER_SIZE];
-static size_t rbuf_out;
-static size_t rbuf_in;
-
-static char lbuf[BUFFER_SIZE + 1];
-static size_t lbuf_used;
-
-static char fbuf[BUFFER_SIZE];
+typedef struct {
+	tcp_conn_t *conn;
+
+	char rbuf[BUFFER_SIZE];
+	size_t rbuf_out;
+	size_t rbuf_in;
+
+	char lbuf[BUFFER_SIZE + 1];
+	size_t lbuf_used;
+} recv_t;
 
 static bool verbose = false;
@@ -131,15 +133,38 @@
     "</html>\r\n";
 
+
+static int recv_create(tcp_conn_t *conn, recv_t **rrecv)
+{
+	recv_t *recv;
+	
+	recv = calloc(1, sizeof(recv_t));
+	if (recv == NULL)
+		return ENOMEM;
+	
+	recv->conn = conn;
+	recv->rbuf_out = 0;
+	recv->rbuf_in = 0;
+	recv->lbuf_used = 0;
+	
+	*rrecv = recv;
+	return EOK;
+}
+
+static void recv_destroy(recv_t *recv)
+{
+	free(recv);
+}
+
 /** Receive one character (with buffering) */
-static int recv_char(tcp_conn_t *conn, char *c)
+static int recv_char(recv_t *recv, char *c)
 {
 	size_t nrecv;
 	int rc;
 	
-	if (rbuf_out == rbuf_in) {
-		rbuf_out = 0;
-		rbuf_in = 0;
-		
-		rc = tcp_conn_recv_wait(conn, rbuf, BUFFER_SIZE, &nrecv);
+	if (recv->rbuf_out == recv->rbuf_in) {
+		recv->rbuf_out = 0;
+		recv->rbuf_in = 0;
+		
+		rc = tcp_conn_recv_wait(recv->conn, recv->rbuf, BUFFER_SIZE, &nrecv);
 		if (rc != EOK) {
 			fprintf(stderr, "tcp_conn_recv() failed (%d)\n", rc);
@@ -147,20 +172,20 @@
 		}
 		
-		rbuf_in = nrecv;
-	}
-	
-	*c = rbuf[rbuf_out++];
+		recv->rbuf_in = nrecv;
+	}
+	
+	*c = recv->rbuf[recv->rbuf_out++];
 	return EOK;
 }
 
 /** Receive one line with length limit */
-static int recv_line(tcp_conn_t *conn)
-{
-	char *bp = lbuf;
+static int recv_line(recv_t *recv, char **rbuf)
+{
+	char *bp = recv->lbuf;
 	char c = '\0';
 	
-	while (bp < lbuf + BUFFER_SIZE) {
+	while (bp < recv->lbuf + BUFFER_SIZE) {
 		char prev = c;
-		int rc = recv_char(conn, &c);
+		int rc = recv_char(recv, &c);
 		
 		if (rc != EOK)
@@ -172,10 +197,11 @@
 	}
 	
-	lbuf_used = bp - lbuf;
+	recv->lbuf_used = bp - recv->lbuf;
 	*bp = '\0';
 	
-	if (bp == lbuf + BUFFER_SIZE)
+	if (bp == recv->lbuf + BUFFER_SIZE)
 		return ELIMIT;
 	
+	*rbuf = recv->lbuf;
 	return EOK;
 }
@@ -218,24 +244,36 @@
 static int uri_get(const char *uri, tcp_conn_t *conn)
 {
+	char *fbuf = NULL;
+	char *fname = NULL;
+	int rc;
+	int fd = -1;
+	
+	fbuf = calloc(BUFFER_SIZE, 1);
+	if (fbuf == NULL) {
+		rc = ENOMEM;
+		goto out;
+	}
+	
 	if (str_cmp(uri, "/") == 0)
 		uri = "/index.html";
 	
-	char *fname;
-	int rc = asprintf(&fname, "%s%s", WEB_ROOT, uri);
-	if (rc < 0)
-		return ENOMEM;
-	
-	int fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
+	rc = asprintf(&fname, "%s%s", WEB_ROOT, uri);
+	if (rc < 0) {
+		rc = ENOMEM;
+		goto out;
+	}
+	
+	fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
 	if (fd < 0) {
 		rc = send_response(conn, msg_not_found);
-		free(fname);
-		return rc;
+		goto out;
 	}
 	
 	free(fname);
+	fname = NULL;
 	
 	rc = send_response(conn, msg_ok);
 	if (rc != EOK)
-		return rc;
+		goto out;
 	
 	aoff64_t pos = 0;
@@ -246,6 +284,6 @@
 		
 		if (nr < 0) {
-			vfs_put(fd);
-			return EIO;
+			rc = EIO;
+			goto out;
 		}
 		
@@ -253,17 +291,22 @@
 		if (rc != EOK) {
 			fprintf(stderr, "tcp_conn_send() failed\n");
-			vfs_put(fd);
-			return rc;
+			goto out;
 		}
 	}
 	
-	vfs_put(fd);
-	
-	return EOK;
-}
-
-static int req_process(tcp_conn_t *conn)
-{
-	int rc = recv_line(conn);
+	rc = EOK;
+out:
+	if (fd >= 0)
+		vfs_put(fd);
+	free(fname);
+	free(fbuf);
+	return rc;
+}
+
+static int req_process(tcp_conn_t *conn, recv_t *recv)
+{
+	char *reqline = NULL;
+
+	int rc = recv_line(recv, &reqline);
 	if (rc != EOK) {
 		fprintf(stderr, "recv_line() failed\n");
@@ -272,15 +315,15 @@
 	
 	if (verbose)
-		fprintf(stderr, "Request: %s", lbuf);
-	
-	if (str_lcmp(lbuf, "GET ", 4) != 0) {
+		fprintf(stderr, "Request: %s", reqline);
+	
+	if (str_lcmp(reqline, "GET ", 4) != 0) {
 		rc = send_response(conn, msg_not_implemented);
 		return rc;
 	}
 	
-	char *uri = lbuf + 4;
+	char *uri = reqline + 4;
 	char *end_uri = str_chr(uri, ' ');
 	if (end_uri == NULL) {
-		end_uri = lbuf + lbuf_used - 2;
+		end_uri = reqline + str_size(reqline) - 2;
 		assert(*end_uri == '\r');
 	}
@@ -300,5 +343,5 @@
 static void usage(void)
 {
-	printf("Skeletal server\n"
+	printf("Simple web server\n"
 	    "\n"
 	    "Usage: " NAME " [options]\n"
@@ -363,23 +406,36 @@
 {
 	int rc;
+	recv_t *recv = NULL;
 	
 	if (verbose)
 		fprintf(stderr, "New connection, waiting for request\n");
 	
-	rbuf_out = 0;
-	rbuf_in = 0;
-	
-	rc = req_process(conn);
+	rc = recv_create(conn, &recv);
+	if (rc != EOK) {
+		fprintf(stderr, "Out of memory.\n");
+		goto error;
+	}
+	
+	rc = req_process(conn, recv);
 	if (rc != EOK) {
 		fprintf(stderr, "Error processing request (%s)\n",
 		    str_error(rc));
-		return;
-	}
-
+		goto error;
+	}
+	
 	rc = tcp_conn_send_fin(conn);
 	if (rc != EOK) {
 		fprintf(stderr, "Error sending FIN.\n");
-		return;
-	}
+		goto error;
+	}
+
+	recv_destroy(recv);
+	return;
+error:
+	rc = tcp_conn_reset(conn);
+	if (rc != EOK)
+		fprintf(stderr, "Error resetting connection.\n");
+	
+	recv_destroy(recv);
 }
 
Index: uspace/drv/audio/hdaudio/hdaudio.c
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/drv/audio/hdaudio/hdaudio.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,6 @@
 #include <bitops.h>
 #include <ddi.h>
+#include <device/hw_res.h>
 #include <device/hw_res_parsed.h>
-#include <irc.h>
 #include <stdio.h>
 #include <errno.h>
@@ -175,5 +175,5 @@
 
 	ddf_msg(LVL_NOTE, "create parent sess");
-	hda->parent_sess = ddf_dev_parent_sess_create(dev);
+	hda->parent_sess = ddf_dev_parent_sess_get(dev);
 	if (hda->parent_sess == NULL) {
 		ddf_msg(LVL_ERROR, "Failed connecting parent driver.\n");
@@ -257,5 +257,5 @@
 	ddf_msg(LVL_NOTE, "range0.base=%zu", hdaudio_irq_pio_ranges[0].base);
 
-	rc = irc_enable_interrupt(res.irqs.irqs[0]);
+	rc = hw_res_enable_interrupt(hda->parent_sess, res.irqs.irqs[0]);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed enabling interrupt. (%d)", rc);
@@ -263,7 +263,8 @@
 	}
 
-	rc = register_interrupt_handler(dev, res.irqs.irqs[0],
+	int irq_cap = register_interrupt_handler(dev, res.irqs.irqs[0],
 	    hdaudio_interrupt, &irq_code);
-	if (rc != EOK) {
+	if (irq_cap < 0) {
+		rc = irq_cap;
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler. (%d)",
 		    rc);
Index: uspace/drv/audio/sb16/dsp.c
===================================================================
--- uspace/drv/audio/sb16/dsp.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/drv/audio/sb16/dsp.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,6 +35,6 @@
 #include <as.h>
 #include <stdbool.h>
+#include <ddf/driver.h>
 #include <ddi.h>
-#include <devman.h>
 #include <device/hw_res.h>
 #include <libarch/ddi.h>
@@ -75,5 +75,5 @@
 		[DSP_NO_BUFFER] = "NO BUFFER",
 	};
-	if (state < ARRAY_SIZE(state_names))
+	if ((size_t)state < ARRAY_SIZE(state_names))
 		return state_names[state];
 	return "UNKNOWN";
@@ -144,7 +144,9 @@
 {
 	dsp_write(dsp, SET_SAMPLING_RATE_OUTPUT);
-	dsp_write(dsp, rate >> 8);
-	dsp_write(dsp, rate & 0xff);
-	ddf_log_verbose("Sampling rate: %hhx:%hhx.", rate >> 8, rate & 0xff);
+	uint8_t rate_lo = rate & 0xff;
+	uint8_t rate_hi = rate >> 8;
+	dsp_write(dsp, rate_hi);
+	dsp_write(dsp, rate_lo);
+	ddf_log_verbose("Sampling rate: %hhx:%hhx.", rate_hi, rate_lo);
 }
 
@@ -159,13 +161,9 @@
 static inline int setup_dma(sb_dsp_t *dsp, uintptr_t pa, size_t size)
 {
-	async_sess_t *sess = devman_parent_device_connect(
-	    ddf_dev_get_handle(dsp->sb_dev), IPC_FLAG_BLOCKING);
-
-	const int ret = hw_res_dma_channel_setup(sess,
+	async_sess_t *sess = ddf_dev_parent_sess_get(dsp->sb_dev);
+
+	return hw_res_dma_channel_setup(sess,
 	    dsp->dma16_channel, pa, size,
 	    DMA_MODE_READ | DMA_MODE_AUTO | DMA_MODE_ON_DEMAND);
-
-	async_hangup(sess);
-	return ret;
 }
 
@@ -202,9 +200,4 @@
 	
 	return ret;
-}
-
-static inline size_t sample_count(pcm_sample_format_t format, size_t byte_count)
-{
-	return byte_count / pcm_sample_format_size(format);
 }
 
@@ -307,10 +300,8 @@
 
 	assert(dsp->buffer.data);
-	async_sess_t *sess = devman_parent_device_connect(
-	    ddf_dev_get_handle(dsp->sb_dev), IPC_FLAG_BLOCKING);
+	async_sess_t *sess = ddf_dev_parent_sess_get(dsp->sb_dev);
 
 	// TODO: Assumes DMA 16
 	const int remain = hw_res_dma_channel_remain(sess, dsp->dma16_channel);
-	async_hangup(sess);
 	if (remain >= 0) {
 		*pos = dsp->buffer.size - remain;
Index: uspace/drv/audio/sb16/main.c
===================================================================
--- uspace/drv/audio/sb16/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/drv/audio/sb16/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,4 @@
 #include <ddf/log.h>
 #include <device/hw_res_parsed.h>
-#include <devman.h>
 #include <assert.h>
 #include <stdio.h>
@@ -51,5 +50,5 @@
 static int sb_get_res(ddf_dev_t *device, addr_range_t **pp_sb_regs,
     addr_range_t **pp_mpu_regs, int *irq, int *dma8, int *dma16);
-static int sb_enable_interrupts(ddf_dev_t *device);
+static int sb_enable_interrupt(ddf_dev_t *device, int irq);
 
 static driver_ops_t sb_driver_ops = {
@@ -94,4 +93,5 @@
 	irq_cmd_t irq_cmds[irq_cmd_count];
 	irq_pio_range_t irq_ranges[1];
+	int irq_cap;
 
 	sb16_t *soft_state = ddf_dev_data_alloc(device, sizeof(sb16_t));
@@ -123,6 +123,8 @@
 	};
 
-	rc = register_interrupt_handler(device, irq, irq_handler, &irq_code);
-	if (rc != EOK) {
+	irq_cap = register_interrupt_handler(device, irq, irq_handler,
+	    &irq_code);
+	if (irq_cap < 0) {
+		rc = irq_cap;
 		ddf_log_error("Failed to register irq handler: %s.",
 		    str_error(rc));
@@ -132,5 +134,5 @@
 	handler_regd = true;
 
-	rc = sb_enable_interrupts(device);
+	rc = sb_enable_interrupt(device, irq);
 	if (rc != EOK) {
 		ddf_log_error("Failed to enable interrupts: %s.",
@@ -168,5 +170,5 @@
 error:
 	if (handler_regd)
-		unregister_interrupt_handler(device, irq);
+		unregister_interrupt_handler(device, irq_cap);
 	return rc;
 }
@@ -177,7 +179,6 @@
 	assert(device);
 
-	async_sess_t *parent_sess = devman_parent_device_connect(
-	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
-	if (!parent_sess)
+	async_sess_t *parent_sess = ddf_dev_parent_sess_get(device);
+	if (parent_sess == NULL)
 		return ENOMEM;
 
@@ -185,5 +186,4 @@
 	hw_res_list_parsed_init(&hw_res);
 	const int ret = hw_res_get_list_parsed(parent_sess, &hw_res, 0);
-	async_hangup(parent_sess);
 	if (ret != EOK) {
 		return ret;
@@ -242,15 +242,11 @@
 }
 
-int sb_enable_interrupts(ddf_dev_t *device)
-{
-	async_sess_t *parent_sess = devman_parent_device_connect(
-	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
-	if (!parent_sess)
+static int sb_enable_interrupt(ddf_dev_t *device, int irq)
+{
+	async_sess_t *parent_sess = ddf_dev_parent_sess_get(device);
+	if (parent_sess == NULL)
 		return ENOMEM;
 
-	bool enabled = hw_res_enable_interrupt(parent_sess);
-	async_hangup(parent_sess);
-
-	return enabled ? EOK : EIO;
+	return hw_res_enable_interrupt(parent_sess, irq);
 }
 
Index: uspace/drv/block/ahci/ahci.c
===================================================================
--- uspace/drv/block/ahci/ahci.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/drv/block/ahci/ahci.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,7 +36,7 @@
 #include <ddf/interrupt.h>
 #include <ddf/log.h>
+#include <device/hw_res.h>
 #include <device/hw_res_parsed.h>
 #include <pci_dev_iface.h>
-#include <irc.h>
 #include <ahci_iface.h>
 #include "ahci.h"
@@ -1140,5 +1140,5 @@
 	
 	/* Connect to parent device */
-	ahci->parent_sess = ddf_dev_parent_sess_create(dev);
+	ahci->parent_sess = ddf_dev_parent_sess_get(dev);
 	if (ahci->parent_sess == NULL)
 		return NULL;
@@ -1185,12 +1185,13 @@
 	ct.ranges = ahci_ranges;
 	
-	int rc = register_interrupt_handler(dev, hw_res_parsed.irqs.irqs[0],
-	    ahci_interrupt, &ct);
-	if (rc != EOK) {
+	int irq_cap = register_interrupt_handler(dev,
+	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, &ct);
+	if (irq_cap < 0) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler.");
 		goto error_register_interrupt_handler;
 	}
 	
-	rc = irc_enable_interrupt(hw_res_parsed.irqs.irqs[0]);
+	int rc = hw_res_enable_interrupt(ahci->parent_sess,
+	    hw_res_parsed.irqs.irqs[0]);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed enable interupt.");
@@ -1202,5 +1203,5 @@
 	
 error_enable_interrupt:
-	unregister_interrupt_handler(dev, hw_res_parsed.irqs.irqs[0]);
+	unregister_interrupt_handler(dev, irq_cap);
 	
 error_register_interrupt_handler:
Index: uspace/drv/block/ahci/ahci.h
===================================================================
--- uspace/drv/block/ahci/ahci.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/drv/block/ahci/ahci.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,5 +35,4 @@
 
 #include <async.h>
-#include <devman.h>
 #include <ddf/interrupt.h>
 #include <stdio.h>
@@ -92,7 +91,4 @@
 	ahci_port_is_t event_pxis;
 	
-	/** Block device service id. */
-	service_id_t service_id;
-	
 	/** Number of device data blocks. */
 	uint64_t blocks;
Index: uspace/drv/block/ata_bd/main.c
===================================================================
--- uspace/drv/block/ata_bd/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/drv/block/ata_bd/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -68,5 +68,5 @@
 	int rc;
 
-	parent_sess = ddf_dev_parent_sess_create(dev);
+	parent_sess = ddf_dev_parent_sess_get(dev);
 	if (parent_sess == NULL)
 		return ENOMEM;
Index: uspace/drv/block/ddisk/ddisk.c
===================================================================
--- uspace/drv/block/ddisk/ddisk.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/drv/block/ddisk/ddisk.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -112,4 +112,6 @@
 	ddisk_regs_t *ddisk_regs;
 
+	int irq_cap;
+
 	bd_srvs_t bds;
 } ddisk_t;
@@ -286,5 +288,5 @@
 	int rc;
 
-	parent_sess = ddf_dev_parent_sess_create(dev);
+	parent_sess = ddf_dev_parent_sess_get(dev);
 	if (parent_sess == NULL)
 		return ENOMEM;
@@ -447,4 +449,6 @@
 	ddisk->bds.sarg = ddisk;
 
+	ddisk->irq_cap = -1;
+
 	/*
 	 * Enable access to ddisk's PIO registers.
@@ -499,7 +503,8 @@
 	ddisk_irq_commands[0].addr = (void *) &res_phys->status;
 	ddisk_irq_commands[3].addr = (void *) &res_phys->command;
-	rc = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
+	ddisk->irq_cap = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
 	    ddisk_irq_handler, &ddisk_irq_code);
-	if (rc != EOK) {
+	if (ddisk->irq_cap < 0) {
+		rc = ddisk->irq_cap;
 		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
 		goto error;
@@ -541,5 +546,5 @@
 	}
 
-	unregister_interrupt_handler(ddisk->dev, ddisk->ddisk_res.irq);
+	unregister_interrupt_handler(ddisk->dev, ddisk->irq_cap);
 	
 	rc = pio_disable(ddisk->ddisk_regs, sizeof(ddisk_regs_t));
Index: uspace/drv/bus/adb/cuda_adb/Makefile
===================================================================
--- uspace/drv/bus/adb/cuda_adb/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/drv/bus/adb/cuda_adb/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,38 @@
+#
+# Copyright (c) 2010 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../../..
+LIBS = $(LIBDRV_PREFIX)/libdrv.a
+EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include
+BINARY = cuda_adb
+
+SOURCES = \
+	cuda_adb.c \
+	main.c
+
+include $(USPACE_PREFIX)/Makefile.common
